searchNodes=[{"doc":"","ref":"prx.html","title":"prx","type":"module"},{"doc":"Register a function to be called at task termination. The atexit function runs in the parent of the process. atexit/2 must use prx_drv:call/4 to manipulate the task. Examples The default function closes stdin, stdout and stderr of the system process: fun ( Drv , Pipeline , Pid ) -&gt; prx_drv : call ( Drv , Pipeline , close , [ maps : get ( stdout , Pid ) ] ) , prx_drv : call ( Drv , Pipeline , close , [ maps : get ( stdin , Pid ) ] ) , prx_drv : call ( Drv , Pipeline , close , [ maps : get ( stderr , Pid ) ] ) end","ref":"prx.html#atexit/2","title":"prx.atexit/2","type":"function"},{"doc":"Make a synchronous call into the port driver The list of available calls and their arguments can be found here: https://hexdocs.pm/alcove/alcove.html#functions For example, to directly call alcove:execve/5 : Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; prx : call ( Task , execve , [ &quot;/bin/ls&quot; , [ &quot;/bin/ls&quot; , &quot;-al&quot; ] , [ &quot;HOME=/home/foo&quot; ] ] ) . ok","ref":"prx.html#call/3","title":"prx.call/3","type":"function"},{"doc":"cap_enter(2): place process into capability mode Support • FreeBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.158 . 0 &gt; } 3 &gt; prx : cap_enter ( Task1 ) . ok 4 &gt; prx : kill ( Task1 , 0 , 0 ) . { error , ecapmode } 5 &gt; prx : kill ( Task , 0 , 0 ) . ok","ref":"prx.html#cap_enter/1","title":"prx.cap_enter/1","type":"function"},{"doc":"cap_fcntls_get(2): get allowed fcntl commands in capability mode Support • FreeBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.165 . 0 &gt; } 3 &gt; { ok , FD } = prx : open ( Task1 , &quot;/etc/passwd&quot; , [ o_rdonly ] ) . { ok , 7 } 4 &gt; prx : cap_enter ( Task1 ) . ok 5 &gt; prx : cap_fcntls_get ( Task1 , FD ) . { ok , 120 }","ref":"prx.html#cap_fcntls_get/2","title":"prx.cap_fcntls_get/2","type":"function"},{"doc":"cap_fcntls_limit(2): manage fcntl commands in capability mode Support • FreeBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.165 . 0 &gt; } 3 &gt; { ok , FD } = prx : open ( Task1 , &quot;/etc/passwd&quot; , [ o_rdonly ] ) . { ok , 7 } 4 &gt; prx : cap_enter ( Task1 ) . ok 5 &gt; prx : cap_fcntls_get ( Task1 , FD ) . { ok , 120 } 6 &gt; prx : cap_fcntls_limit ( Task1 , FD , [ cap_fcntl_setfl ] ) . ok 7 &gt; prx : cap_fcntls_get ( Task1 , FD ) . { ok , 16 }","ref":"prx.html#cap_fcntls_limit/3","title":"prx.cap_fcntls_limit/3","type":"function"},{"doc":"cap_getmode(2): check if capability mode is enabled • 0 : false • 1 : true Support • FreeBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.165 . 0 &gt; } 3 &gt; prx : cap_enter ( Task1 ) . ok 4 &gt; prx : cap_getmode ( Task ) . { ok , 0 } 5 &gt; prx : cap_getmode ( Task1 ) . { ok , 1 }","ref":"prx.html#cap_getmode/1","title":"prx.cap_getmode/1","type":"function"},{"doc":"cap_ioctls_limit(2): manage allowed ioctl commands Support • FreeBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.158 . 0 &gt; } 3 &gt; { ok , FD } = prx : open ( Task1 , &quot;/dev/pts/1&quot; , [ o_rdwr , o_nonblock ] ) . { ok , 7 } 4 &gt; prx : cap_enter ( Task1 ) . ok 5 &gt; prx : cap_ioctls_limit ( Task1 , FD , [ tiocmget , tiocgwinsz ] ) . ok 6 &gt; prx : ioctl ( Task1 , FD , tiocmset , &lt;&lt; &gt;&gt; ) . { error , enotcapable } 7 &gt; prx : ioctl ( Task1 , FD , tiocmget , &lt;&lt; &gt;&gt; ) . { ok , \#{ arg =&gt; &lt;&lt; &gt;&gt; , return_value =&gt; 0 } }","ref":"prx.html#cap_ioctls_limit/3","title":"prx.cap_ioctls_limit/3","type":"function"},{"doc":"cap_rights_limit(2): manage process capabilities Support • FreeBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.168 . 0 &gt; } 3 &gt; { ok , FD } = prx : open ( Task1 , &quot;/etc/passwd&quot; , [ o_rdonly ] ) . { ok , 7 } 4 &gt; prx : cap_enter ( Task1 ) . ok 5 &gt; prx : cap_rights_limit ( Task1 , FD , [ cap_read ] ) . ok 6 &gt; prx : read ( Task1 , FD , 64 ) . { ok , &lt;&lt; &quot;# $FreeBSD$\\n#\\nroot:*:0:0:Charlie &amp;:/root:/bin/csh\\ntoor:*:0:0:Bou&quot; &gt;&gt; } 7 &gt; prx : lseek ( Task1 , FD , 0 , 0 ) . { error , enotcapable } 8 &gt; prx : open ( Task1 , &quot;/etc/passwd&quot; , [ o_rdonly ] ) . { error , ecapmode }","ref":"prx.html#cap_rights_limit/3","title":"prx.cap_rights_limit/3","type":"function"},{"doc":"chdir(2): change process current working directory Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.178 . 0 &gt; } 3 &gt; prx : chdir ( Task , &quot;/&quot; ) . ok 4 &gt; prx : chdir ( Task1 , &quot;/tmp&quot; ) . ok 5 &gt; prx : getcwd ( Task ) . { ok , &lt;&lt; &quot;/&quot; &gt;&gt; } 6 &gt; prx : getcwd ( Task1 ) . { ok , &lt;&lt; &quot;/tmp&quot; &gt;&gt; }","ref":"prx.html#chdir/2","title":"prx.chdir/2","type":"function"},{"doc":"chmod(2): change file permissions Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.178 . 0 &gt; } 3 &gt; { ok , FD } = prx : open ( Task1 , &quot;/tmp/testfile.txt&quot; , [ o_wronly , o_creat ] , 8#644 ) . { ok , 7 } 4 &gt; prx : chmod ( Task1 , &quot;/tmp/testfile.txt&quot; , 8#400 ) . ok","ref":"prx.html#chmod/3","title":"prx.chmod/3","type":"function"},{"doc":"chown(2): change file ownership Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.155 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.159 . 0 &gt; } 4 &gt; { ok , FD } = prx : open ( Task1 , &quot;/tmp/testfile.txt&quot; , [ o_wronly , o_creat ] , 8#644 ) . { ok , 7 } 5 &gt; prx : chown ( Task1 , &quot;/tmp/testfile.txt&quot; , 0 , 0 ) . ok","ref":"prx.html#chown/4","title":"prx.chown/4","type":"function"},{"doc":"chroot(2): change root directory Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.155 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.159 . 0 &gt; } 4 &gt; prx : chroot ( Task1 , &quot;/tmp&quot; ) . ok 5 &gt; prx : chdir ( Task1 , &quot;/&quot; ) . ok 6 &gt; prx : getcwd ( Task1 ) . { ok , &lt;&lt; &quot;/&quot; &gt;&gt; }","ref":"prx.html#chroot/2","title":"prx.chroot/2","type":"function"},{"doc":"clearenv(3): zero process environment Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.155 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.159 . 0 &gt; } 3 &gt; prx : clearenv ( Task1 ) . ok 4 &gt; prx : environ ( Task1 ) . [ ]","ref":"prx.html#clearenv/1","title":"prx.clearenv/1","type":"function"},{"doc":"clone(2): create a new process Support • Linux Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : clone ( Task , [ clone_newns , clone_newpid , clone_newipc , clone_newuts , clone_newnet ] ) . { ok , &lt; 0.184 . 0 &gt; } 4 &gt; prx : getpid ( Task1 ) . 1","ref":"prx.html#clone/2","title":"prx.clone/2","type":"function"},{"doc":"close(2): close a file descriptor Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.178 . 0 &gt; } 3 &gt; { ok , FD } = prx : open ( Task1 , &quot;/tmp/testfile.txt&quot; , [ o_wronly , o_creat ] , 8#644 ) . { ok , 7 } 4 &gt; prx : close ( Task1 , FD ) . ok","ref":"prx.html#close/2","title":"prx.close/2","type":"function"},{"doc":"","ref":"prx.html#cmd/2","title":"prx.cmd/2","type":"function"},{"doc":"Assign a new process owner call mode : the controlling process is allowed to make calls to the prx process. exec mode : the controlling process receives standard output and standard error from the prx process","ref":"prx.html#controlling_process/2","title":"prx.controlling_process/2","type":"function"},{"doc":"Returns the list of child PIDs for this process. Each child task is a map composed of: • pid: system pid • exec: true if the child has called exec() • fdctl: parent end of CLOEXEC file descriptor used to monitor if the child process has called exec() • stdin: parent end of the child process' standard input • stdout: parent end of the child process' standard output • stderr: parent end of the child process' standard error Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.182 . 0 &gt; } 3 &gt; { ok , Task2 } = prx : fork ( Task ) . { ok , &lt; 0.184 . 0 &gt; } 4 &gt; prx : cpid ( Task ) . [ \#{ exec =&gt; true , fdctl =&gt; - 2 , flowcontrol =&gt; - 1 , pid =&gt; 27809 , signaloneof =&gt; 15 , stderr =&gt; 13 , stdin =&gt; 10 , stdout =&gt; 11 } , \#{ exec =&gt; false , fdctl =&gt; 9 , flowcontrol =&gt; - 1 , pid =&gt; 27810 , signaloneof =&gt; 15 , stderr =&gt; 17 , stdin =&gt; 14 , stdout =&gt; 15 } ]","ref":"prx.html#cpid/1","title":"prx.cpid/1","type":"function"},{"doc":"Retrieve process info for forked processes Retrieve the map for a child process as returned in prx:cpid/1. cpid/2 searches the list of a process' children for a PID (an erlang or a system PID) and returns a map containing the parent's file descriptors towards the child. See also: cpid/1 .","ref":"prx.html#cpid/2","title":"prx.cpid/2","type":"function"},{"doc":"Get the gen_server PID for the task Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } &lt; 0.181 . 0 &gt;","ref":"prx.html#drv/1","title":"prx.drv/1","type":"function"},{"doc":"environ(7): return the process environment variables Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; prx : environ ( Task ) . [ &lt;&lt; &quot;LANG=C.UTF-8&quot; &gt;&gt; , &lt;&lt; &quot;PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin&quot; &gt;&gt; , &lt;&lt; &quot;TERM=screen&quot; &gt;&gt; , &lt;&lt; &quot;SHELL=/bin/bash&quot; &gt;&gt; ]","ref":"prx.html#environ/1","title":"prx.environ/1","type":"function"},{"doc":"Close stdin of child process Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.176 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , 19048 } 3 &gt; prx : execvp ( Task , [ &quot;cat&quot; ] ) . ok 4 &gt; prx : eof ( Task , Task1 ) . ok","ref":"prx.html#eof/2","title":"prx.eof/2","type":"function"},{"doc":"Close stdin, stdout or stderr of child process. See also: eof/2 .","ref":"prx.html#eof/3","title":"prx.eof/3","type":"function"},{"doc":"Test if the task has called exec(2) Returns true if the task is running in exec mode. Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.182 . 0 &gt; } 3 &gt; prx : execed ( Task1 ) . false 4 &gt; prx : execvp ( Task1 , [ &quot;cat&quot; ] ) . ok 5 &gt; prx : execed ( Task1 ) . true","ref":"prx.html#execed/1","title":"prx.execed/1","type":"function"},{"doc":"execve(2): replace process image with environment Replace the process image, specifying the environment for the new process image. Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; prx : execvp ( Task , &quot;cat&quot; , [ &quot;name-in-process-list&quot; , &quot;-n&quot; ] ) ok","ref":"prx.html#execve/3","title":"prx.execve/3","type":"function"},{"doc":"execve(2): replace process image with environment Replace the process image, specifying the environment for the new process image. Examples Set the command name in the process list: 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; prx : execve ( Task , &quot;/bin/cat&quot; , [ &quot;name-in-process-list&quot; , &quot;-n&quot; ] , [ &quot;VAR=1&quot; ] ) . ok","ref":"prx.html#execve/4","title":"prx.execve/4","type":"function"},{"doc":"execvp(2): replace the current process image using the search path Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.194 . 0 &gt; } 3 &gt; prx : execvp ( Task1 , [ &quot;cat&quot; , &quot;-n&quot; ] ) . ok 4 &gt; prx : stdin ( Task1 , &lt;&lt; &quot;test\\n&quot; &gt;&gt; ) . ok 5 &gt; flush ( ) . Shell got { stdout , &lt; 0.194 . 0 &gt; , &lt;&lt; &quot; 1\\ttest\\n&quot; &gt;&gt; } ok","ref":"prx.html#execvp/2","title":"prx.execvp/2","type":"function"},{"doc":"execvp(2): replace the current process image using the search path Examples Set the command name in the process list: 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; prx : execvp ( Task , &quot;cat&quot; , [ &quot;name-in-process-list&quot; , &quot;-n&quot; ] ) ok","ref":"prx.html#execvp/3","title":"prx.execvp/3","type":"function"},{"doc":"exit(3): cause an prx control process to exit Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.178 . 0 &gt; } 3 &gt; prx : exit ( Task1 , 111 ) . ok 4 &gt; flush ( ) . Shell got { exit_status , &lt; 0.159 . 0 &gt; , 111 } ok","ref":"prx.html#exit/2","title":"prx.exit/2","type":"function"},{"doc":"fcntl(2) : perform operation on a file descriptor See also: fcntl/4 .","ref":"prx.html#fcntl/3","title":"prx.fcntl/3","type":"function"},{"doc":"fcntl(2): perform operations on a file descriptor with argument Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; Stdin = 0 . 0 3 &gt; prx : fcntl ( Task , Stdin , f_getfd , 0 ) . { ok , 0 }","ref":"prx.html#fcntl/4","title":"prx.fcntl/4","type":"function"},{"doc":"fexecve(2): replace the process image Replace the process image, specifying the environment for the new process image, using a previously opened file descriptor. The file descriptor can be set to close after exec() by passing the O_CLOEXEC flag to open: { ok , FD } = prx : open ( Task , &quot;/bin/ls&quot; , [ o_rdonly , o_cloexec ] ) , ok = prx : fexecve ( Task , FD , [ &quot;-al&quot; ] , [ &quot;FOO=123&quot; ] ) . Linux requires an environment to be set unlike with execve(2). The environment can be empty: % Environment required on Linux ok = prx : fexecve ( Task , FD , [ &quot;ls&quot; , &quot;-al&quot; ] , [ &quot;&quot; ] ) . Support • Linux • FreeBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.184 . 0 &gt; } 3 &gt; { ok , FD } = prx : open ( Task1 , &quot;/usr/bin/env&quot; , [ o_rdonly , o_cloexec ] , 0 ) . { ok , 7 } 4 &gt; prx : fexecve ( Task1 , FD , [ &quot;env&quot; , &quot;-0&quot; ] , [ &quot;FOO=123&quot; ] ) . ok 5 &gt; flush ( ) . Shell got { stdout , &lt; 0.208 . 0 &gt; , &lt;&lt; 70 , 79 , 79 , 61 , 49 , 50 , 51 , 0 &gt;&gt; } Shell got { exit_status , &lt; 0.208 . 0 &gt; , 0 } ok","ref":"prx.html#fexecve/4","title":"prx.fexecve/4","type":"function"},{"doc":"filter/2 : restrict control process calls Restricts the set of calls available to a prx control process. If fork is allowed, any subsequently forked control processes inherit the set of filtered calls: { ok , Ctrl } = prx : fork ( ) , ok = prx : filter ( Ctrl , [ getpid ] ) , { ok , Task } = prx : fork ( Ctrl ) , { &#39;EXIT&#39; , { undef , _ } } = ( catch prx : getpid ( Task ) ) . See also: filter/3 .","ref":"prx.html#filter/2","title":"prx.filter/2","type":"function"},{"doc":"filter/3 : restrict control process and subprocess calls filter/3 specifies the set of calls available to a prx control process and any subsequently forked control processes. Control processes continue to proxy data and monitor and reap subprocesses. Invoking a filtered call will crash the process with 'undef'. If the filter/3 call is filtered, subsequent calls to filter/3 will fail. Calls can be either allowed or denied. If a call is allowed, all other calls are filtered. Once a filter for a call is added, the call cannot be removed from the filter set. Passing an empty list ([]) specifies the current filter set should not be modified. % the set of calls to filter, any forked control subprocesses % are unrestricted prx : filter ( Task , { deny , [ getpid , execve , execvp ] } , [ ] ) % equivalent to {deny, [getpid, execve, execvp]} prx : filter ( Task , [ getpid , execve , execvp ] , [ ] ) % all other calls are filtered including filter prx : filter ( Task , { allow , [ fork , clone , kill ] } , [ ] ) % init: control process can fork, subprocesses can exec a data process prx : filter ( Task , { allow , [ fork , clone , kill ] } , { allow , [ execve , execvp ] } ) Examples 1 &gt; catch_exception ( true ) . false 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } %% % Control process: restricted to: fork, filter, getcwd %% % Any forked control subprocess: restricted to: getpid, gethostname 2 &gt; prx : filter ( Task , { allow , [ fork , filter , getcwd ] } , { allow , [ getpid , gethosname ] } ) . ok 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.190 . 0 &gt; } 4 &gt; prx : getpid ( Task ) . * exception error : undefined function prx : getpid / 1 5 &gt; prx : getcwd ( Task1 ) . * exception error : undefined function prx : getcwd / 1 6 &gt; prx : getcwd ( Task ) . { ok , &lt;&lt; &quot;/&quot; &gt;&gt; }","ref":"prx.html#filter/3","title":"prx.filter/3","type":"function"},{"doc":"fork(2): create a new system process The behaviour of the process can be controlled by setting the application environment: Option = { exec , string ( ) } | { progname , string ( ) } | { ctldir , string ( ) } • {exec, Exec} Default: &quot;&quot; Sets a command to run the port under such as sudo or valgrind. For example, to start the process as root using sudo , allow running prx as root: sudo visudo - f / etc / sudoers . d / 99 _ prx &lt; user &gt; ALL = NOPASSWD : / path / to / prx / priv / prx Defaults ! / path / to / prx / priv / prx ! requiretty ` ` ` Then : ` ` ` application : set_env ( prx , options , [ { exec , &quot;sudo -n&quot; } ] ) • {progname, Path} Default: priv/prx Sets the path to the prx executable. • {ctldir, Path} Default: priv A control directory writable by the prx port process (the Unix process may be running under a different user than the Erlang VM). The control directory contains a FIFO shared by beam and the port process which is used to notify the Erlang VM that the port process has called exec(). Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.187 . 0 &gt; }","ref":"prx.html#fork/0","title":"prx.fork/0","type":"function"},{"doc":"fork(2): create a child process Forks child processes from an existing task. For example: { ok , Task } = prx : fork ( ) , % PID 16341 { ok , Child1 } = prx : fork ( Task ) , % PID 16349 { ok , Child2 } = prx : fork ( Task ) , % PID 16352 { ok , Child2a } = prx : fork ( Child2 ) , % PID 16354 { ok , Child2aa } = prx : fork ( Child2a ) , % PID 16357 { ok , Child2ab } = prx : fork ( Child2a ) . % PID 16482 Results in a process tree: prx ( 16341 ) - + - prx ( 16349 ) ` - prx ( 16352 ) -- - prx ( 16354 ) - + - prx ( 16357 ) ` - prx ( 16482 ) Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.187 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.191 . 0 &gt; } 3 &gt; prx : cpid ( Task ) . [ \#{ exec =&gt; false , fdctl =&gt; 8 , flowcontrol =&gt; - 1 , pid =&gt; 8098 , signaloneof =&gt; 15 , stderr =&gt; 13 , stdin =&gt; 10 , stdout =&gt; 11 } ]","ref":"prx.html#fork/1","title":"prx.fork/1","type":"function"},{"doc":"Get control process attributes Retrieve attributes set by the prx control process %% for a child process. See also: getcpid/3 .","ref":"prx.html#getcpid/2","title":"prx.getcpid/2","type":"function"},{"doc":"Get control process attributes Retrieves attributes set by the prx control process for a child process. • flowcontrol Number of messages allowed from process: -1 : flowcontrol disabled 0 : stdout/stderr for process is not read 1+ : read this many messages from the process • signaloneof Signal sent to child process on shutdown. Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.178 . 0 &gt; } 3 &gt; prx : getcpid ( Task , Task1 , flowcontrol ) . - 1","ref":"prx.html#getcpid/3","title":"prx.getcpid/3","type":"function"},{"doc":"getcwd(3): return the current working directory Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : chdir ( Task , &quot;/&quot; ) . ok 3 &gt; prx : getcwd ( Task ) . { ok , &lt;&lt; &quot;/&quot; &gt;&gt; }","ref":"prx.html#getcwd/1","title":"prx.getcwd/1","type":"function"},{"doc":"getenv(3): retrieve an environment variable Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : chdir ( Task , &quot;/&quot; ) . ok 6 &gt; prx : getenv ( Task , &quot;TERM&quot; ) . &lt;&lt; &quot;screen&quot; &gt;&gt;","ref":"prx.html#getenv/2","title":"prx.getenv/2","type":"function"},{"doc":"getgid(2): retrieve the process group ID Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getgid ( Task ) . 1000","ref":"prx.html#getgid/1","title":"prx.getgid/1","type":"function"},{"doc":"getgroups(2): retrieve the list of supplementary groups Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getgroups ( Task ) . { ok , [ 24 , 20 , 1000 ] }","ref":"prx.html#getgroups/1","title":"prx.getgroups/1","type":"function"},{"doc":"gethostname(2): retrieve the system hostname Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : gethostname ( Task ) . { ok , &lt;&lt; &quot;host1&quot; &gt;&gt; }","ref":"prx.html#gethostname/1","title":"prx.gethostname/1","type":"function"},{"doc":"Retrieve port options for event loop Options are configurable per process, with the default settings inherited from the parent. • maxchild : non_neg_integer() : 64 Number of child processes allowed for this control process. The value can be modified using setopt/4,5. Additionally, reducing RLIMIT_NOFILE for the process may result in a reduced maxchild value. • exit_status : 1 | 0 : 1 Controls whether the controlling Erlang process is informed of a process exit value. • maxforkdepth : non_neg_integer() : 16 Sets the maximum length of the prx process pipeline. • termsig : 1 | 0 : 1 If a child process exits because of a signal, notify the controlling Erlang process. • flowcontrol : int32_t() : -1 (disabled) Sets the default flow control behaviour for a newly forked process. Flow control is applied after the child process calls exec(). See setcpid/5. • signaloneof : 0-255 : 15 Send a signal to a child process on shutdown (stdin of the prx control process is closed). See setcpid/5. Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getopt ( Task , maxchild ) . 64","ref":"prx.html#getopt/2","title":"prx.getopt/2","type":"function"},{"doc":"getpgrp(2): retrieve the process group Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getpgrp ( Task ) . 3924","ref":"prx.html#getpgrp/1","title":"prx.getpgrp/1","type":"function"},{"doc":"getpid(2): retrieve the system PID of the process Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getpid ( Task ) . 3924","ref":"prx.html#getpid/1","title":"prx.getpid/1","type":"function"},{"doc":"getpriority(2): retrieve scheduling priority of process, process group or user Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getpriority ( Task ) . { ok , 0 }","ref":"prx.html#getpriority/3","title":"prx.getpriority/3","type":"function"},{"doc":"getresgid(2): get real, effective and saved group ID Support • Linux • OpenBSD • FreeBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getresgid ( Task ) . { ok , 1000 , 1000 , 1000 }","ref":"prx.html#getresgid/1","title":"prx.getresgid/1","type":"function"},{"doc":"getresuid(2): get real, effective and saved user ID Support • Linux • OpenBSD • FreeBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getresuid ( Task ) . { ok , 1000 , 1000 , 1000 }","ref":"prx.html#getresuid/1","title":"prx.getresuid/1","type":"function"},{"doc":"getrlimit(2): retrieve the resource limits for a process Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 2 &gt; prx : getrlimit ( Task , rlimit_nofile ) . { ok , \#{ cur =&gt; 1024 , max =&gt; 1048576 } }","ref":"prx.html#getrlimit/2","title":"prx.getrlimit/2","type":"function"},{"doc":"getsid(2): retrieve the session ID Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getsid ( Task ) . { ok , 3924 }","ref":"prx.html#getsid/2","title":"prx.getsid/2","type":"function"},{"doc":"getuid(2): returns the process user ID Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 2 &gt; prx : getuid ( Task ) . 1000","ref":"prx.html#getuid/1","title":"prx.getuid/1","type":"function"},{"doc":"ioctl(2) : control device Controls a device using a file descriptor previously obtained using open/4. Argp can be either a binary or a list representation of a C struct. See prctl/6 below for a description of the list elements. On success, ioctl/4 returns a 2-tuple containing a map. The map keys are: • return_value: an integer equal to the return value of the ioctl. Usually 0, however some ioctl's on Linux use the return value as the output parameter. • arg: the value depends on the type of the input parameter Argp. • cstruct: contains the contents of the memory pointed to by Argp • integer/binary: an empty binary Examples An example of creating a tap device in a net namespace on Linux: { ok , Child } = prx : clone ( Task , [ clone_newnet ] ) , { ok , FD } = prx : open ( Child , &quot;/dev/net/tun&quot; , [ o_rdwr ] , 0 ) , { ok , \#{ return_value = 0 , arg = &lt;&lt; &quot;tap&quot; , N , _ / binary &gt;&gt; } } = prx : ioctl ( Child , FD , tunsetiff , &lt;&lt; 0 : ( 16 * 8 ) , % generate a tuntap device name ( 16#0002 bor 16#1000 ) : 2 / native - unsigned - integer - unit : 8 , % IFF_TAP, IFF_NO_PI 0 : ( 14 * 8 ) &gt;&gt; ) , { ok , &lt;&lt; &quot;tap&quot; , N &gt;&gt; } .","ref":"prx.html#ioctl/4","title":"prx.ioctl/4","type":"function"},{"doc":"jail(2): restrict the current process in a system jail Support • FreeBSD Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.155 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.159 . 0 &gt; } 4 &gt; prx : jail ( Task1 , \#{ path =&gt; &quot;/rescue&quot; , hostname =&gt; &quot;test0&quot; , jailname =&gt; &quot;test0&quot; } ) . { ok , 23223 } 5 &gt; prx : gethostname ( Task1 ) . { ok , &lt;&lt; &quot;test0&quot; &gt;&gt; }","ref":"prx.html#jail/2","title":"prx.jail/2","type":"function"},{"doc":"kill(2): terminate a process Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.158 . 0 &gt; } 3 &gt; Pid = prx : getpid ( Task1 ) . 70524 4 &gt; prx : kill ( Task , 0 , 0 ) . ok 5 &gt; prx : kill ( Task , 12345 , 0 ) . { error , esrch } 6 &gt; prx : kill ( Task , Pid , 0 ) . ok 7 &gt; prx : kill ( Task , Pid , sigkill ) . ok 8 &gt; prx : kill ( Task , Pid , 0 ) . { error , esrch } 9 &gt; flush ( ) . Shell got { termsig , &lt; 0.158 . 0 &gt; , sigkill } ok","ref":"prx.html#kill/3","title":"prx.kill/3","type":"function"},{"doc":"lseek(2): set file offset for read/write Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.154 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.169 . 0 &gt; } 3 &gt; { ok , FD } = prx : open ( Task1 , &quot;/etc/passwd&quot; , [ o_rdonly ] ) . { ok , 7 } 4 &gt; prx : lseek ( Task1 , FD , 0 , 0 ) . ok","ref":"prx.html#lseek/4","title":"prx.lseek/4","type":"function"},{"doc":"mkdir(2) : create a directory","ref":"prx.html#mkdir/3","title":"prx.mkdir/3","type":"function"},{"doc":"mkfifo(3) : create a named pipe","ref":"prx.html#mkfifo/3","title":"prx.mkfifo/3","type":"function"},{"doc":"mount(2) : mount a filesystem, Linux style The arguments are: • source • target • filesystem type • flags • data An empty list may be used to specify NULL. For example, filesystems mounted in a Linux mount namespace may be visible in the global mount namespace. To avoid this, first remount the root filesystem within mount namespace using the MS_REC|MS_PRIVATE flags: { ok , Task } = prx : clone ( Parent , [ clone_newns ] ) , ok = prx : mount ( Task , &quot;none&quot; , &quot;/&quot; , &quot;&quot; , [ ms_rec , ms_private ] , &quot;&quot; ) . On BSD systems, the Source argument is ignored and passed to the system mount call as: mount(FSType, Target, Flags, Data); Examples An example of bind mounting a directory within a linux mount namespace: 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.192 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : clone ( Task , [ clone_newns ] ) . { ok , &lt; 0.196 . 0 &gt; } 3 &gt; prx : mount ( Task1 , &quot;/tmp&quot; , &quot;/mnt&quot; , &quot;&quot; , [ ms_bind , ms_rdonly , ms_noexec ] , &quot;&quot; ) . ok 4 &gt; prx : umount ( Task1 , &quot;/mnt&quot; ) . ok","ref":"prx.html#mount/6","title":"prx.mount/6","type":"function"},{"doc":"(Solaris) mount(2) : mount a filesystem On Solaris, some mount options are passed in the Options argument as a string of comma separated values terminated by a NULL. Other platforms ignore the Options parameter. See also: mount/6 .","ref":"prx.html#mount/7","title":"prx.mount/7","type":"function"},{"doc":"open(2): returns a file descriptor associated with a file Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.192 . 0 &gt; } 2 &gt; prx : open ( Task , &quot;/etc/hosts&quot; , [ o_rdonly ] ) . { ok , 7 }","ref":"prx.html#open/3","title":"prx.open/3","type":"function"},{"doc":"open(2) : open a file specifying permissions Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.192 . 0 &gt; } 2 &gt; prx : open ( Task , &quot;/tmp/prx-open-test&quot; , [ o_wronly , o_creat ] , 8#644 ) . { ok , 7 }","ref":"prx.html#open/4","title":"prx.open/4","type":"function"},{"doc":"Get the parent PID for the task Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.208 . 0 &gt; } 3 &gt; prx : parent ( Task ) . noproc 4 &gt; prx : parent ( Task1 ) . &lt; 0.180 . 0 &gt;","ref":"prx.html#parent/1","title":"prx.parent/1","type":"function"},{"doc":"Retrieves the system PID of the process similar to getpid(2) Returns the cached value for the PID of the system process. Works with tasks in exec mode. Warning: pidof/1 for a task returned by fork/0 returns the PID of the first child process. If using sudo/0 , the PID for the sudo helper process is returned. Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.182 . 0 &gt; } 3 &gt; { ok , Task2 } = prx : fork ( Task ) . { ok , &lt; 0.184 . 0 &gt; } 4 &gt; prx : execvp ( Task1 , [ &quot;cat&quot; ] ) . ok 5 &gt; prx : getpid ( Task2 ) . 27810 7 &gt; prx : pidof ( Task2 ) . 27810 8 &gt; prx : pidof ( Task1 ) . 27809","ref":"prx.html#pidof/1","title":"prx.pidof/1","type":"function"},{"doc":"Get the process pipeline list for the task Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; prx : getpid ( Task ) . 8094 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.208 . 0 &gt; } 4 &gt; prx : getpid ( Task1 ) . 8175 5 &gt; { ok , Task2 } = prx : fork ( Task1 ) . { ok , &lt; 0.3006 . 0 &gt; } 6 &gt; prx : getpid ( Task2 ) . 27224 7 &gt; prx : pipeline ( Task2 ) . [ 8175 , 27224 ]","ref":"prx.html#pipeline/1","title":"prx.pipeline/1","type":"function"},{"doc":"pivot_root(2): change the root mount Use pivot_root(2) in a Linux mount namespace to change the root filesystem. Warning: using pivot_root(2) in the global namespace may have unexpected effects. To use an arbitrary directory as a mount point: • mark the mount namespace as private • create a mount point by bind mounting the new root directory over itself • change the current working directory to the new root directory • call pivot_root(2) with new and old root set to the current working directory • unmount the current working directory Support • Linux Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.192 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : clone ( Task , [ clone_newns ] ) . { ok , &lt; 0.196 . 0 &gt; } 4 &gt; prx : mkdir ( Task , &quot;/tmp/prx-root&quot; , 8#755 ) . ok 5 &gt; { ok , Task1 } = prx : clone ( Task , [ clone_newns ] ) . { ok , &lt; 0.210 . 0 &gt; } 6 &gt; prx : mount ( Task1 , &quot;none&quot; , &quot;/&quot; , [ ] , [ ms_rec , ms_private ] , [ ] ) . ok 7 &gt; prx : mount ( Task1 , &quot;/tmp/prx-root&quot; , &quot;/tmp/prx-root&quot; , [ ] , [ ms_bind ] , [ ] ) . ok 8 &gt; prx : chdir ( Task1 , &quot;/tmp/prx-root&quot; ) . ok 9 &gt; prx : pivot_root ( Task1 , &quot;.&quot; , &quot;.&quot; ) . ok 10 &gt; prx : umount2 ( Task1 , &quot;.&quot; , [ mnt_detach ] ) . ok","ref":"prx.html#pivot_root/3","title":"prx.pivot_root/3","type":"function"},{"doc":"pledge(2): restrict system operations An empty list ([]) specifies promises should not be changed. Warning: an empty string (&quot;&quot;) is equivalent to an empty list. To specify no capabilities, use an empty binary: &lt;&lt;&gt;&gt;&gt; or &lt;&lt;&quot;&quot;&gt;&gt; Support • OpenBSD Examples Fork a control process: • restricted to stdio, proc and exec capabilities • unrestricted after calling exec 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.152 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.156 . 0 &gt; } 3 &gt; prx : pledge ( Task , &lt;&lt; &quot;stdio proc exec&quot; &gt;&gt; , [ ] ) . ok","ref":"prx.html#pledge/3","title":"prx.pledge/3","type":"function"},{"doc":"prctl(2) : operations on a process This function can be used to set BPF syscall filters on processes (seccomp mode). A list can be used for prctl operations requiring a C structure as an argument. List elements are used to contiguously populate a buffer (it is up to the caller to add padding): • binary() : the element is copied directly into the buffer On return, the contents of the binary is returned to the caller. • {ptr, N} : N bytes of zero'ed memory is allocated. The pointer is placed in the buffer. On return, the contents of the memory is returned to the caller. • {ptr, binary()} Memory equal to the size of the binary is allocated and initialized with the contents of the binary. On return, the contents of the memory is returned to the caller. Support • Linux Examples The prx process requires the following syscalls to run: sys_exit sys_exit_group sys_getrlimit sys_poll sys_read sys_restart_syscall sys_rt_sigreturn sys_setrlimit sys_sigreturn sys_ugetrlimit sys_write sys_writev To enforce a seccomp filter: - module ( seccomp ) . - include_lib ( &quot;alcove/include/alcove_seccomp.hrl&quot; ) . - export ( [ run / 1 , run / 2 , filter / 2 ] ) . - define ( DENY_SYSCALL ( Syscall ) , [ ? BPF_JUMP ( ? BPF_JMP + ? BPF_JEQ + ? BPF_K , ( Syscall ) , 0 , 1 ) , ? BPF_STMT ( ? BPF_RET + ? BPF_K , ? SECCOMP_RET_KILL ) ] ) . filter ( Task , Syscall ) -&gt; Arch = prx : call ( Task , syscall_constant , [ alcove : audit_arch ( ) ] ) , NR = prx : call ( Task , syscall_constant , [ Syscall ] ) , [ ? VALIDATE_ARCHITECTURE ( Arch ) , ? EXAMINE_SYSCALL , ? DENY_SYSCALL ( NR ) , ? BPF_STMT ( ? BPF_RET + ? BPF_K , ? SECCOMP_RET_ALLOW ) ] . run ( Task ) -&gt; run ( Task , sys_getcwd ) . run ( Task , Syscall ) -&gt; Filter = filter ( Task , Syscall ) , { ok , _ , _ , _ , _ , _ } = prx : prctl ( Task , pr_set_no_new_privs , 1 , 0 , 0 , 0 ) , Pad = ( erlang : system_info ( { wordsize , external } ) - 2 ) * 8 , Prog = [ &lt;&lt; ( iolist_size ( Filter ) div 8 ) : 2 / native - unsigned - integer - unit : 8 &gt;&gt; , &lt;&lt; 0 : Pad &gt;&gt; , { ptr , list_to_binary ( Filter ) } ] , %% prx:seccomp(Task, seccomp_set_mode_filter, 0, Prog) prx : prctl ( Task , pr_set_seccomp , seccomp_mode_filter , Prog , 0 , 0 ) . To enforce the filter: 1 &gt; catch_exception ( true ) . false 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.186 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.191 . 0 &gt; } 4 &gt; seccomp : run ( Task1 , sys_getcwd ) . { ok , 0 , 2 , [ &lt;&lt; 7 , 0 &gt;&gt; , &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; , { ptr , &lt;&lt; 32 , 0 , 0 , 0 , 4 , 0 , 0 , 0 , 21 , 0 , 1 , 0 , 62 , 0 , 0 , 192 , 6 , 0 , 0 , 0 , . . . &gt;&gt; } ] , 0 , 0 } 5 &gt; prx : getcwd ( Task1 ) . See also: seccomp/4 .","ref":"prx.html#prctl/6","title":"prx.prctl/6","type":"function"},{"doc":"procctl(2): control processes Support • FreeBSD Examples Pid = prx : pidof ( Task ) , prx : procctl ( Task , 0 , Pid , &#39;PROC_REAP_ACQUIRE&#39; , [ ] ) , prx : procctl ( Task , p_pid , Pid , &#39;PROC_REAP_STATUS&#39; , [ &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , % rs_flags &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , % rs_children &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , % rs_descendants &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , % rs_reaper &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; % rs_pid ] ) .","ref":"prx.html#procctl/5","title":"prx.procctl/5","type":"function"},{"doc":"ptrace(2): process trace Examples - module ( ptrace ) . - export ( [ run / 0 ] ) . run ( ) -&gt; { ok , Task } = prx : fork ( ) , { ok , Task1 } = prx : fork ( Task ) , { ok , Task2 } = prx : fork ( Task1 ) , Pid2 = prx : pidof ( Task2 ) , % disable the prx event loop: child process must be managed by % the caller { ok , sig_dfl } = prx : sigaction ( Task1 , sigchld , sig_info ) , % enable ptracing in the child process and exec() a command { ok , 0 , &lt;&lt; &gt;&gt; , &lt;&lt; &gt;&gt; } = prx : ptrace ( Task2 , ptrace_traceme , 0 , 0 , 0 ) , ok = prx : execvp ( Task2 , &quot;cat&quot; , [ &quot;cat&quot; ] ) , % the parent is notified ok = receive { signal , Task1 , sigchld , _ } -&gt; ok after 5000 -&gt; timeout end , { ok , Pid2 , _ , [ { stopsig , sigtrap } ] } = prx : waitpid ( Task1 , - 1 , [ wnohang ] ) , % should be no other events { ok , 0 , 0 , [ ] } = prx : waitpid ( Task1 , - 1 , [ wnohang ] ) , % allow the process to continue { ok , 0 , &lt;&lt; &gt;&gt; , &lt;&lt; &gt;&gt; } = prx : ptrace ( Task1 , ptrace_cont , Pid2 , 0 , 0 ) , ok = prx : stdin ( Task2 , &quot;test\\n&quot; ) , ok = receive { stdout , Task2 , &lt;&lt; &quot;test\\n&quot; &gt;&gt; } -&gt; ok after 5000 -&gt; timeout end , % Send a SIGTERM and re-write it to a harmless SIGWINCH ok = prx : kill ( Task1 , Pid2 , sigterm ) , ok = receive { signal , Task1 , sigchld , _ } -&gt; ok after 5000 -&gt; timeout end , { ok , Pid2 , _ , [ { stopsig , sigterm } ] } = prx : waitpid ( Task1 , - 1 , [ wnohang ] ) , { ok , 0 , &lt;&lt; &gt;&gt; , &lt;&lt; &gt;&gt; } = prx : ptrace ( Task1 , ptrace_cont , Pid2 , 0 , 28 ) , % Convert a SIGWINCH to SIGTERM ok = prx : kill ( Task1 , Pid2 , sigwinch ) , ok = receive { signal , Task1 , sigchld , _ } -&gt; ok after 5000 -&gt; timeout end , { ok , 0 , &lt;&lt; &gt;&gt; , &lt;&lt; &gt;&gt; } = prx : ptrace ( Task1 , ptrace_cont , Pid2 , 0 , 15 ) , { ok , Pid2 , _ , [ { termsig , sigterm } ] } = prx : waitpid ( Task1 , - 1 , [ ] ) .","ref":"prx.html#ptrace/5","title":"prx.ptrace/5","type":"function"},{"doc":"read(2): read bytes from a file descriptor Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.212 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.216 . 0 &gt; } 3 &gt; { ok , FD } = prx : open ( Task1 , &quot;/etc/hosts&quot; , [ o_rdonly ] ) . { ok , 7 } 4 &gt; prx : read ( Task1 , FD , 64 ) . { ok , &lt;&lt; &quot;127.0.0.1 localhost\\n\\n# The following lines are desirable for IPv&quot; &gt;&gt; }","ref":"prx.html#read/3","title":"prx.read/3","type":"function"},{"doc":"readdir(3): retrieve list of objects in a directory Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.212 . 0 &gt; } 2 &gt; prx : readdir ( Task , &quot;/dev/pts&quot; ) . { ok , [ &lt;&lt; &quot;.&quot; &gt;&gt; , &lt;&lt; &quot;..&quot; &gt;&gt; , &lt;&lt; &quot;66&quot; &gt;&gt; , &lt;&lt; &quot;63&quot; &gt;&gt; , &lt;&lt; &quot;67&quot; &gt;&gt; , &lt;&lt; &quot;64&quot; &gt;&gt; , &lt;&lt; &quot;62&quot; &gt;&gt; , &lt;&lt; &quot;61&quot; &gt;&gt; , &lt;&lt; &quot;60&quot; &gt;&gt; , &lt;&lt; &quot;59&quot; &gt;&gt; , &lt;&lt; &quot;58&quot; &gt;&gt; , &lt;&lt; &quot;57&quot; &gt;&gt; , &lt;&lt; &quot;56&quot; &gt;&gt; , &lt;&lt; &quot;55&quot; &gt;&gt; , &lt;&lt; &quot;54&quot; &gt;&gt; , &lt;&lt; &quot;53&quot; &gt;&gt; , &lt;&lt; &quot;52&quot; &gt;&gt; , &lt;&lt; &quot;51&quot; &gt;&gt; , &lt;&lt; &quot;50&quot; &gt;&gt; , &lt;&lt; &quot;49&quot; &gt;&gt; , &lt;&lt; &quot;48&quot; &gt;&gt; , &lt;&lt; &quot;47&quot; &gt;&gt; , &lt;&lt; &quot;46&quot; &gt;&gt; , &lt;&lt; &quot;45&quot; &gt;&gt; , &lt;&lt; &quot;44&quot; &gt;&gt; , &lt;&lt; &quot;43&quot; &gt;&gt; , &lt;&lt; . . . &gt;&gt; | . . . ] }","ref":"prx.html#readdir/2","title":"prx.readdir/2","type":"function"},{"doc":"Fork+exec prx process. Fork+exec is a way of randomizing the memory space of a process: https://poolp.org/posts/2016-09-12/opensmtpd-6.0.0-is-released/ prx processes fork recursively: • the calls stack increases in size • the memory space layout is identical to the parent After forking a prx process using fork/1, the controlling process will typically instruct the new prx process to execute a command using one of the exec(3) functions: execvp/2, execve/3. Some &quot;system&quot; or &quot;supervisor&quot; type processes may remain in call mode: these processes can call reexec/1 to exec() the port. On platforms supporting fexecve(2) (FreeBSD, Linux), prx will open a file descriptor to the port binary and use it to re-exec() the port. On other OS'es, execve(2) will be used with the the default path to the port binary. If the binary is not accessible or, on Linux, /proc is not mounted, reexec/1 will fail. Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.216 . 0 &gt; } 2 &gt; prx : getpid ( Task1 ) . 8175 3 &gt; prx : reexec ( Task1 ) . ok 4 &gt; prx : getpid ( Task1 ) . 8175","ref":"prx.html#reexec/1","title":"prx.reexec/1","type":"function"},{"doc":"Replace the port process image using execve(2)/fexecve(2). Specify the port program path or a file descriptor to the binary and the process environment. See also: reexec/1 .","ref":"prx.html#reexec/3","title":"prx.reexec/3","type":"function"},{"doc":"Equivalent to reexec / 1.","ref":"prx.html#replace_process_image/1","title":"prx.replace_process_image/1","type":"function"},{"doc":"Equivalent to reexec / 3.","ref":"prx.html#replace_process_image/3","title":"prx.replace_process_image/3","type":"function"},{"doc":"rmdir(2): delete a directory Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.212 . 0 &gt; } 2 &gt; prx : mkdir ( Task , &quot;/tmp/prx-rmdir-test&quot; , 8#755 ) . ok 3 &gt; prx : rmdir ( Task , &quot;/tmp/prx-rmdir-test&quot; ) . ok","ref":"prx.html#rmdir/2","title":"prx.rmdir/2","type":"function"},{"doc":"seccomp(2) : restrict system operations Support • Linux Examples %% Equivalent to: %% prx:prctl(Task, pr_set_seccomp, seccomp_mode_filter, Prog, 0, 0). prx : seccomp ( Task , seccomp_set_mode_filter , 0 , Prog ) See also: prctl/6 .","ref":"prx.html#seccomp/4","title":"prx.seccomp/4","type":"function"},{"doc":"select(2): poll a list of file descriptor for events select/5 will block until an event occurs on a file descriptor, a timeout is reached or interrupted by a signal. The Timeout value may be: • an empty list ([]): causes select to block indefinitely (no timeout) • a map indicating the timeout The map contains these fields: • sec : number of seconds to wait • usec : number of microseconds to wait Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; { ok , FD } = prx : open ( Task , &quot;/dev/null&quot; , [ o_rdwr ] , 0 ) . { ok , 7 } 3 &gt; prx : select ( Task , [ FD ] , [ FD ] , [ FD ] , [ ] ) . { ok , [ 7 ] , [ 7 ] , [ ] } 4 &gt; prx : select ( Task , [ FD ] , [ FD ] , [ FD ] , \#{ sec =&gt; 1 , usec =&gt; 1 } ) . { ok , [ 7 ] , [ 7 ] , [ ] }","ref":"prx.html#select/5","title":"prx.select/5","type":"function"},{"doc":"setcpid() : Set options for child process of prx control process Control behaviour of an exec()'ed process. See also: setcpid/4 .","ref":"prx.html#setcpid/3","title":"prx.setcpid/3","type":"function"},{"doc":"setcpid() : Set options for child process of prx control process flowcontrol enables rate limiting of the stdout and stderr of a child process. stdin is not rate limited (default: -1 (disabled)) • 0: stdout/stderr for process is not read • 1-2147483646: read this many messages from the process • -1: disable flow control NOTE: the limit applies to stdout and stderr. If the limit is set to 1, it is possible to get: • 1 message from stdout • 1 message from stderr • 1 message from stdout and stderr signaloneof delivers a signal to any subprocesses when the alcove control process shuts down (default: 15 (SIGTERM)) Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.162 . 0 &gt; } 3 &gt; prx : setcpid ( Task1 , flowcontrol , 0 ) . true 4 &gt; prx : getcpid ( Task1 , flowcontrol ) . 0","ref":"prx.html#setcpid/4","title":"prx.setcpid/4","type":"function"},{"doc":"setenv(3): set an environment variable Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 2 &gt; prx : setenv ( Task , &quot;TEST&quot; , &quot;foo&quot; , 0 ) . ok 3 &gt; prx : getenv ( Task , &quot;TEST&quot; ) . &lt;&lt; &quot;foo&quot; &gt;&gt; 4 &gt; prx : setenv ( Task , &quot;TEST&quot; , &quot;bar&quot; , 0 ) . ok 5 &gt; prx : getenv ( Task , &quot;TEST&quot; ) . &lt;&lt; &quot;foo&quot; &gt;&gt; 6 &gt; prx : setenv ( Task , &quot;TEST&quot; , &quot;bar&quot; , 1 ) . ok 7 &gt; prx : getenv ( Task , &quot;TEST&quot; ) . &lt;&lt; &quot;bar&quot; &gt;&gt;","ref":"prx.html#setenv/4","title":"prx.setenv/4","type":"function"},{"doc":"setgid(2): set the GID of the process Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.159 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.163 . 0 &gt; } 4 &gt; prx : setgid ( Task1 , 123 ) . ok 5 &gt; prx : getgid ( Task1 ) . 123","ref":"prx.html#setgid/2","title":"prx.setgid/2","type":"function"},{"doc":"setgroups(2): set the supplementary groups of the process Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.160 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.164 . 0 &gt; } 4 &gt; prx : setgroups ( Task1 , [ ] ) . ok 5 &gt; prx : getgroups ( Task1 ) . { ok , [ ] }","ref":"prx.html#setgroups/2","title":"prx.setgroups/2","type":"function"},{"doc":"sethostname(2): set the system hostname This function is probably only useful if running in a uts namespace or a jail. Examples { ok , Child } = prx : clone ( Task , [ clone_newuts ] ) , ok = prx : sethostname ( Child , &quot;test&quot; ) , Hostname1 = prx : gethostname ( Task ) , Hostname2 = prx : gethostname ( Child ) , Hostname1 =/= Hostname2 .","ref":"prx.html#sethostname/2","title":"prx.sethostname/2","type":"function"},{"doc":"setns(2): attach to a namespace A process namespace is represented as a path in the /proc filesystem. The path is /proc/&lt;pid&gt;/ns/&lt;ns&gt; , where: • pid: the system PID • ns: a file representing the namespace The available namespaces is dependent on the kernel version. You can see which are supported by running: ls - al / proc / $$ / ns Support • Linux Examples Attach a process to an existing network namespace: { ok , Child1 } = prx : clone ( Task , [ clone_newnet ] ) , { ok , Child2 } = prx : fork ( Task ) , % Move Child2 into the Child1 network namespace { ok , FD } = prx : open ( Child2 , [ &quot;/proc/&quot; , integer_to_list ( Child1 ) , &quot;/ns/net&quot; ] , [ o_rdonly ] , 0 ) , ok = prx : setns ( Child2 , FD ) , ok = prx : close ( Child2 , FD ) .","ref":"prx.html#setns/2","title":"prx.setns/2","type":"function"},{"doc":"(Linux) setns(2) : attach to a namespace, specifying namespace type ok = prx : setns ( Task , FD , clone_newnet ) See also: setns/2 .","ref":"prx.html#setns/3","title":"prx.setns/3","type":"function"},{"doc":"Set port options Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.160 . 0 &gt; } 2 &gt; prx : setopt ( Task , maxforkdepth , 128 ) . true See also: getopt/2 .","ref":"prx.html#setopt/3","title":"prx.setopt/3","type":"function"},{"doc":"setpgid(2): set process group Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.162 . 0 &gt; } 3 &gt; prx : setpgid ( Task1 , 0 , 0 ) . ok","ref":"prx.html#setpgid/3","title":"prx.setpgid/3","type":"function"},{"doc":"setpriority(2): set scheduling priority of process, process group or user Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.162 . 0 &gt; } 3 &gt; prx : setpriority ( Task1 , prio_process , 0 , 10 ) . ok 4 &gt; prx : getpriority ( Task1 , prio_process , 0 ) . { ok , 10 }","ref":"prx.html#setpriority/4","title":"prx.setpriority/4","type":"function"},{"doc":"setproctitle(3): set the process title Set the process title displayed in utilities like ps(1) by overwriting the command's arg0. Linux systems may also want to set the command name using prctl/6 : prx : prctl ( Task , pr_set_name , &lt;&lt; &quot;newname&quot; &gt;&gt; , 0 , 0 , 0 ) Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.177 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , 28210 } 3 &gt; prx : setproctitle ( Task1 , &quot;new process name&quot; ) . ok See also: prctl/6 .","ref":"prx.html#setproctitle/2","title":"prx.setproctitle/2","type":"function"},{"doc":"setresgid(2): set real, effective and saved group ID Support • Linux • FreeBSD • OpenBSD Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.162 . 0 &gt; } 4 &gt; prx : setresgid ( Task1 , 123 , 123 , 123 ) . ok","ref":"prx.html#setresgid/4","title":"prx.setresgid/4","type":"function"},{"doc":"setresuid(2): set real, effective and saved user ID Support • Linux • FreeBSD • OpenBSD Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.162 . 0 &gt; } 3 &gt; prx : setresuid ( Task1 , 123 , 123 , 123 ) . ok","ref":"prx.html#setresuid/4","title":"prx.setresuid/4","type":"function"},{"doc":"setrlimit(2): set a resource limit Note on rlimit_nofile : The control process requires a fixed number of file descriptors for each subprocess. Reducing the number of file descriptors will reduce the limit on child processes. If the file descriptor limit is below the number of file descriptors currently used, setrlimit/4,5 will return {error, einval} . Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.162 . 0 &gt; } 3 &gt; prx : getrlimit ( Task1 , rlimit_nofile ) . { ok , \#{ cur =&gt; 1048576 , max =&gt; 1048576 } } 4 &gt; prx : setrlimit ( Task1 , rlimit_nofile , \#{ cur =&gt; 64 , max =&gt; 64 } ) . ok 5 &gt; prx : getrlimit ( Task1 , rlimit_nofile ) . { ok , \#{ cur =&gt; 64 , max =&gt; 64 } } 6 &gt; prx : getrlimit ( Task , rlimit_nofile ) . { ok , \#{ cur =&gt; 1048576 , max =&gt; 1048576 } }","ref":"prx.html#setrlimit/3","title":"prx.setrlimit/3","type":"function"},{"doc":"setsid(2): create a new session Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.162 . 0 &gt; } 3 &gt; prx : setsid ( Task1 ) . { ok , 32141 }","ref":"prx.html#setsid/1","title":"prx.setsid/1","type":"function"},{"doc":"setuid(2): change UID Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.162 . 0 &gt; } 3 &gt; prx : setuid ( Task1 , 123 ) . ok 3 &gt; prx : getuid ( Task1 ) . 123 See also: setresuid/4 .","ref":"prx.html#setuid/2","title":"prx.setuid/2","type":"function"},{"doc":"","ref":"prx.html#sh/2","title":"prx.sh/2","type":"function"},{"doc":"sigaction(2): set process behaviour for signals • sig_dfl Uses the default behaviour for the signal • sig_ign Ignores the signal • sig_info Catches the signal and sends the controlling Erlang process an event: { signal , atom ( ) , Info } Info is a binary containing the siginfo_t structure. See sigaction(2) for details. • [] Returns the current handler for the signal. Multiple caught signals of the same type may be reported as one event. Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.182 . 0 &gt; } 3 &gt; prx : kill ( Task , prx : pidof ( Task1 ) , sigterm ) . ok 4 &gt; flush ( ) . Shell got { signal , &lt; 0.182 . 0 &gt; , sigterm , &lt;&lt; 15 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 156 , 126 , 0 , 0 , 232 , 3 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; } ok 5 &gt; prx : sigaction ( Task1 , sigterm , sig_ign ) . { ok , sig_info } 6 &gt; prx : kill ( Task , prx : pidof ( Task1 ) , sigterm ) . ok 7 &gt; flush ( ) . ok 8 &gt; prx : sigaction ( Task1 , sigterm , sig_info ) . { ok , sig_ign } 9 &gt; prx : kill ( Task , prx : pidof ( Task1 ) , sigterm ) . ok 10 &gt; flush ( ) . Shell got { signal , &lt; 0.182 . 0 &gt; , sigterm , &lt;&lt; 15 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 156 , 126 , 0 , 0 , 232 , 3 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; } ok","ref":"prx.html#sigaction/3","title":"prx.sigaction/3","type":"function"},{"doc":"socket(2): returns a file descriptor for a communication endpoint Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; { ok , FD } = prx : socket ( Task , af_inet , sock_stream , 0 ) . { ok , 7 }","ref":"prx.html#socket/4","title":"prx.socket/4","type":"function"},{"doc":"Send data to the standard input of the process Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.194 . 0 &gt; } 3 &gt; prx : execvp ( Task1 , [ &quot;cat&quot; , &quot;-n&quot; ] ) . ok 4 &gt; prx : stdin ( Task1 , &lt;&lt; &quot;test\\n&quot; &gt;&gt; ) . ok 5 &gt; flush ( ) . Shell got { stdout , &lt; 0.194 . 0 &gt; , &lt;&lt; &quot; 1\\ttest\\n&quot; &gt;&gt; } ok","ref":"prx.html#stdin/2","title":"prx.stdin/2","type":"function"},{"doc":"Assign a process to receive stdio Change the process receiving prx standard output and standard error. stdio/2 and controlling_process/2 can be used to transfer a prx process between erlang processes without losing output when exec(3) is called: ~~~ ok = prx:stdio(Owner, NewOwner), ok = prx:execvp(Owner, Argv), ok = prx:controlling_process(Owner, NewOwner). ~~~","ref":"prx.html#stdio/2","title":"prx.stdio/2","type":"function"},{"doc":"Terminate the task Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.180 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.184 . 0 &gt; } 4 &gt; prx : stop ( Task1 ) . ok 5 &gt; prx : cpid ( Task ) . [ ]","ref":"prx.html#stop/1","title":"prx.stop/1","type":"function"},{"doc":"Convenience function to fork a privileged process in the shell. Sets the application environment so prx can fork a privileged process. sudo must be configured to run the prx binary. The application environment must be set before prx:fork/0 is called. Equivalent to: application : set_env ( prx , options , [ { exec , &quot;sudo -n&quot; } ] ) , { ok , Task } = prx : fork ( ) , 0 = prx : getuid ( Task ) . Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.199 . 0 &gt; } 3 &gt; prx : getuid ( Task ) . 0","ref":"prx.html#sudo/0","title":"prx.sudo/0","type":"function"},{"doc":"Convenience function to fork a privileged process in the shell. Allows specifying the command. Examples For example, on OpenBSD: 1 &gt; prx : sudo ( &quot;doas&quot; ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.199 . 0 &gt; } 3 &gt; prx : getuid ( Task ) . 0","ref":"prx.html#sudo/1","title":"prx.sudo/1","type":"function"},{"doc":"Fork a subprocess and run a sequence of operations task/3 uses fork/1 to create a new subprocess and run a sequence of system calls. If an operations fails, the subprocess is sent SIGKILL and exits. Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.349 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : task ( Task , [ 2 &gt; { chdir , [ &quot;/&quot; ] } , 2 &gt; { setrlimit , [ rlimit_core , \#{ cur =&gt; 0 , max =&gt; 0 } ] } , 2 &gt; { prx , chdir , [ &quot;/nonexistent&quot; ] , [ { errexit , false } ] } 2 &gt; ] , [ ] ) . { ok , &lt; 0.382 . 0 &gt; } 3 &gt; prx : getrlimit ( Task1 , rlimit_core ) . { ok , \#{ cur =&gt; 0 , max =&gt; 0 } } 4 &gt; prx : getcwd ( Task1 ) . { ok , &lt;&lt; &quot;/&quot; &gt;&gt; } See also: task/4 .","ref":"prx.html#task/3","title":"prx.task/3","type":"function"},{"doc":"Create a subprocess and run a sequence of operations using optional function calls task/4 calls the optional init function provided in the Config argument to create a new subprocess. The default init function uses fork/1 . The subprocess next performs a list of operations. Operations are tuples consisting of: * the module name: optional if modifier is not present, defaults to prx * the module function * function arguments * modifier list [ % equivalent to prx:setresgid(65534, 65534, 65534) { setresgid , [ 65534 , 65534 , 65534 ] } , % equivalent to prx:setresuid(65534, 65534, 65534), error is ignored { prx , setresuid , [ 65534 , 65534 , 65534 ] , [ { errexit , false } ] } , ] If an operation returns {error, term()} , the sequence of operations is aborted and the terminate function is run. The default terminate functions signals the subprocess with SIGKILL. Examples 1 &gt; Init = fun ( Parent ) -&gt; 1 &gt; prx : clone ( Parent , [ 1 &gt; clone_newnet , 1 &gt; clone_newuser 1 &gt; ] ) 1 &gt; end . # Fun &lt; erl_eval . 44.65746770 &gt; 2 &gt; Terminate = fun ( Parent , Child ) -&gt; 2 &gt; prx : stop ( Child ) , 2 &gt; prx : kill ( Parent , prx : pidof ( Child ) , sigterm ) 2 &gt; end . # Fun &lt; erl_eval . 43.65746770 &gt; 3 &gt; { ok , Task } = prx : fork ( ) . 4 &gt; { ok , Task1 } = prx : task ( Task , [ 4 &gt; { chdir , [ &quot;/&quot; ] } , 4 &gt; { setrlimit , [ rlimit_core , \#{ cur =&gt; 0 , max =&gt; 0 } ] } , 4 &gt; { prx , chdir , [ &quot;/nonexistent&quot; ] , [ { errexit , false } ] } 4 &gt; ] , [ ] , [ 4 &gt; { init , Init } , 4 &gt; { terminate , Terminate } 4 &gt; ] ) . { ok , &lt; 0.398 . 0 &gt; } 5 &gt; prx : execvp ( Task1 , [ &quot;ip&quot; , &quot;a&quot; ] ) . ok 27 &gt; flush ( ) . Shell got { stdout , &lt; 0.398 . 0 &gt; , &lt;&lt; &quot;1: lo: &lt;LOOPBACK&gt; mtu 65536 qdisc noop state DOWN group default qlen 1000\\n link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00\\n&quot; &gt;&gt; } Shell got { exit_status , &lt; 0.398 . 0 &gt; , 0 } ok See also: prx_task .","ref":"prx.html#task/4","title":"prx.task/4","type":"function"},{"doc":"umount2(2) : unmount a filesystem On BSD systems, calls unmount(2). Examples See also: pivot_root/3 .","ref":"prx.html#umount2/3","title":"prx.umount2/3","type":"function"},{"doc":"umount(2): unmount a filesystem On BSD systems, calls unmount(2). Examples An example of bind mounting a directory within a linux mount namespace: 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.192 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : clone ( Task , [ clone_newns ] ) . { ok , &lt; 0.196 . 0 &gt; } 3 &gt; prx : mount ( Task1 , &quot;/tmp&quot; , &quot;/mnt&quot; , &quot;&quot; , [ ms_bind , ms_rdonly , ms_noexec ] , &quot;&quot; ) . ok 4 &gt; prx : umount ( Task1 , &quot;/mnt&quot; ) . ok","ref":"prx.html#umount/2","title":"prx.umount/2","type":"function"},{"doc":"unlink(2): delete a name from the filesystem Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; prx : open ( Task , &quot;/tmp/testfile&quot; , [ o_wronly , o_creat ] , 8#644 ) . { ok , 8 } 3 &gt; prx : unlink ( Task , &quot;/tmp/testfile&quot; ) . ok","ref":"prx.html#unlink/2","title":"prx.unlink/2","type":"function"},{"doc":"unsetenv(3): remove an environment variable Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; prx : setenv ( Task , &quot;TEST&quot; , &quot;foo&quot; , 0 ) . ok 3 &gt; prx : getenv ( Task , &quot;TEST&quot; ) . &lt;&lt; &quot;foo&quot; &gt;&gt; 4 &gt; prx : unsetenv ( Task , &quot;TEST&quot; ) . ok 5 &gt; prx : getenv ( Task , &quot;TEST&quot; ) . false","ref":"prx.html#unsetenv/2","title":"prx.unsetenv/2","type":"function"},{"doc":"unshare(2): create a new namespace in the current process Make a new namespace without calling clone(2): % The port is now running in a namespace without network access. ok = prx : unshare ( Task , [ clone_newnet ] ) . Examples 1 &gt; prx : sudo ( ) . ok 2 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.179 . 0 &gt; } 3 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.183 . 0 &gt; } 4 &gt; prx : unshare ( Task1 , [ clone_newuts ] ) . ok 5 &gt; prx : sethostname ( Task1 , &quot;unshare&quot; ) . ok 6 &gt; prx : gethostname ( Task1 ) . { ok , &lt;&lt; &quot;unshare&quot; &gt;&gt; } 7 &gt; prx : gethostname ( Task ) . { ok , &lt;&lt; &quot;host1&quot; &gt;&gt; }","ref":"prx.html#unshare/2","title":"prx.unshare/2","type":"function"},{"doc":"unveil(2): restrict filesystem view To disable unveil calls, use an empty list ([]) or, equivalently, an empty string (&quot;&quot;). prx : unveil ( Task , &lt;&lt; &quot;/etc&quot; &gt;&gt; , &lt;&lt; &quot;r&quot; &gt;&gt; ) , prx : unveil ( Task , [ ] , [ ] ) . Support • OpenBSD Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.152 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.156 . 0 &gt; } 3 &gt; prx : unveil ( Task1 , &lt;&lt; &quot;/etc&quot; &gt;&gt; , &lt;&lt; &quot;r&quot; &gt;&gt; ) . ok 4 &gt; prx : unveil ( Task1 , [ ] , [ ] ) . ok 5 &gt; prx : readdir ( Task1 , &quot;/etc&quot; ) . { ok , [ &lt;&lt; &quot;.&quot; &gt;&gt; , &lt;&lt; &quot;..&quot; &gt;&gt; , &lt;&lt; &quot;acme&quot; &gt;&gt; , &lt;&lt; &quot;amd&quot; &gt;&gt; , &lt;&lt; &quot;authpf&quot; &gt;&gt; , &lt;&lt; &quot;daily&quot; &gt;&gt; , &lt;&lt; &quot;disktab&quot; &gt;&gt; , &lt;&lt; &quot;examples&quot; &gt;&gt; , &lt;&lt; &quot;firmware&quot; &gt;&gt; , &lt;&lt; &quot;hotplug&quot; &gt;&gt; , &lt;&lt; &quot;iked&quot; &gt;&gt; , &lt;&lt; &quot;isakmpd&quot; &gt;&gt; , &lt;&lt; &quot;ldap&quot; &gt;&gt; , &lt;&lt; &quot;magic&quot; &gt;&gt; , &lt;&lt; &quot;mail&quot; &gt;&gt; , &lt;&lt; &quot;moduli&quot; &gt;&gt; , &lt;&lt; &quot;monthly&quot; &gt;&gt; , &lt;&lt; &quot;mtree&quot; &gt;&gt; , &lt;&lt; &quot;netstart&quot; &gt;&gt; , &lt;&lt; &quot;npppd&quot; &gt;&gt; , &lt;&lt; &quot;pf.os&quot; &gt;&gt; , &lt;&lt; &quot;ppp&quot; &gt;&gt; , &lt;&lt; &quot;protocols&quot; &gt;&gt; , &lt;&lt; &quot;rc&quot; &gt;&gt; , &lt;&lt; &quot;rc.conf&quot; &gt;&gt; , &lt;&lt; &quot;rc.d&quot; &gt;&gt; , &lt;&lt; . . . &gt;&gt; | . . . ] } 6 &gt; prx : readdir ( Task1 , &quot;/tmp&quot; ) . { error , enoent }","ref":"prx.html#unveil/3","title":"prx.unveil/3","type":"function"},{"doc":"waitpid(2): wait for process to change state Process state changes are handled by the alcove SIGCHLD event handler by default. To use waitpid/4,5, disable the signal handler: { ok , sig_dfl } = prx : sigaction ( Task , sigchld , sig_info ) , { ok , Child } = prx : fork ( Task ) , Pid = prx : getpid ( Child ) , ok = prx : exit ( Child , 2 ) , { ok , Pid , _ , [ { exit_status , 2 } ] } = prx : waitpid ( Task , Pid , [ wnohang ] ) . Note: if the default SIGCHLD handler is disabled, waitpid/4,5 should be called to reap zombie processes: prx : waitpid ( Task , - 1 , [ wnohang ] ) Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.158 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : fork ( Task ) . { ok , &lt; 0.162 . 0 &gt; } 3 &gt; prx : sigaction ( Task1 , sigchld , sig_info ) . { ok , sig_dfl } 4 &gt; prx : execvp ( Task1 , [ &quot;sleep&quot; , &quot;20&quot; ] ) . ok 5 &gt; prx : waitpid ( Task , - 1 , [ ] ) . { ok , 30958 , 0 , [ { exit_status , 0 } ] }","ref":"prx.html#waitpid/3","title":"prx.waitpid/3","type":"function"},{"doc":"write(2): write to a file descriptor Writes a buffer to a file descriptor and returns the number of bytes written. Examples 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.178 . 0 &gt; } 2 &gt; { ok , FD } = prx : open ( Task , &quot;/tmp/testfile&quot; , [ o_wronly , o_creat ] , 8#644 ) . { ok , 7 } 3 &gt; prx : write ( Task , FD , &lt;&lt; &quot;test&quot; &gt;&gt; ) . { ok , 4 } -spec write(task(), fd(), iodata()) -&gt; {ok, ssize_t()} | {error, posix()}.","ref":"prx.html#write/3","title":"prx.write/3","type":"function"},{"doc":"","ref":"prx.html#t:call/0","title":"prx.call/0","type":"type"},{"doc":"","ref":"prx.html#t:constant/0","title":"prx.constant/0","type":"type"},{"doc":"","ref":"prx.html#t:cpid/0","title":"prx.cpid/0","type":"type"},{"doc":"","ref":"prx.html#t:cstruct/0","title":"prx.cstruct/0","type":"type"},{"doc":"","ref":"prx.html#t:fd/0","title":"prx.fd/0","type":"type"},{"doc":"","ref":"prx.html#t:gid_t/0","title":"prx.gid_t/0","type":"type"},{"doc":"","ref":"prx.html#t:int32_t/0","title":"prx.int32_t/0","type":"type"},{"doc":"","ref":"prx.html#t:int64_t/0","title":"prx.int64_t/0","type":"type"},{"doc":"","ref":"prx.html#t:mode_t/0","title":"prx.mode_t/0","type":"type"},{"doc":"","ref":"prx.html#t:off_t/0","title":"prx.off_t/0","type":"type"},{"doc":"","ref":"prx.html#t:pid_t/0","title":"prx.pid_t/0","type":"type"},{"doc":"","ref":"prx.html#t:posix/0","title":"prx.posix/0","type":"type"},{"doc":"","ref":"prx.html#t:prx_opt/0","title":"prx.prx_opt/0","type":"type"},{"doc":"","ref":"prx.html#t:ptr_arg/0","title":"prx.ptr_arg/0","type":"type"},{"doc":"","ref":"prx.html#t:ptr_val/0","title":"prx.ptr_val/0","type":"type"},{"doc":"","ref":"prx.html#t:size_t/0","title":"prx.size_t/0","type":"type"},{"doc":"","ref":"prx.html#t:ssize_t/0","title":"prx.ssize_t/0","type":"type"},{"doc":"","ref":"prx.html#t:task/0","title":"prx.task/0","type":"type"},{"doc":"","ref":"prx.html#t:uid_t/0","title":"prx.uid_t/0","type":"type"},{"doc":"","ref":"prx.html#t:uint32_t/0","title":"prx.uint32_t/0","type":"type"},{"doc":"","ref":"prx.html#t:uint64_t/0","title":"prx.uint64_t/0","type":"type"},{"doc":"","ref":"prx.html#t:waitstatus/0","title":"prx.waitstatus/0","type":"type"},{"doc":"","ref":"prx_drv.html","title":"prx_drv","type":"module"},{"doc":"Make a synchronous call into the port driver. The list of available calls and their arguments can be found here: https://github.com/msantos/alcove#alcove-1 For example, to directly call alcove:execve/5 : call ( Drv , Pipeline , execve , [ &quot;/bin/ls&quot; , [ &quot;/bin/ls&quot; , &quot;-al&quot; ] , [ &quot;HOME=/home/foo&quot; ] ] )","ref":"prx_drv.html#call/4","title":"prx_drv.call/4","type":"function"},{"doc":"Send standard input to process.","ref":"prx_drv.html#stdin/3","title":"prx_drv.stdin/3","type":"function"},{"doc":"","ref":"prx_drv.html#stop/1","title":"prx_drv.stop/1","type":"function"},{"doc":"Create a subprocess and run a sequence of operations. The prx_task module provides functions for creating a new process from a prx:task/0 , running a series of operations on the subprocess and cleaning up on error. The new task is returned to the caller.","ref":"prx_task.html","title":"prx_task","type":"module"},{"doc":"Fork and configure a subprocess Returns a new process created using prx:fork/0 after performing the list of operations on the subprocess. If an operation returns an error, the process is terminated using SIGKILL.","ref":"prx_task.html#do/3","title":"prx_task.do/3","type":"function"},{"doc":"Fork and configure a subprocess Returns a new process created using the init function provided in the Config argument list afer the process has run the list of operations. If an operation fails, the subprocess is terminated using the terminate function. If init or terminate functions are not provided, the default functions are used. See also: with/3 .","ref":"prx_task.html#do/4","title":"prx_task.do/4","type":"function"},{"doc":"Run a sequence of operations on a task The with function runs a sequence of operations on a task. Operations are tuples or list of tuples: * module name: optional if modifier not used, defaults to prx * module function * function arguments * modifier options (see prx_task:option/0 ) Setuid = true , [ % equivalent to prx:chdir(&quot;/&quot;) { chdir , [ &quot;/&quot; ] } , % equivalent to prx:setsid(), error is ignored { prx , setsid , [ ] , [ { errexit , false } ] } , % the op list can contain op lists [ case Setuid of true -&gt; [ { setresgid , [ 65534 , 65534 , 65534 ] } , { setresuid , [ 65534 , 65534 , 65534 ] } ] ; false -&gt; [ ] end ] ] The called function must return one of: * ok * {ok, any()} * {error, any()} Any other value will return a badop tuple containing the failing module, function and argument list. If the op returns an ok tuple, the second element can optionally be passed as state to the next operation. The initial state can be set using the State argument to with/3 . Examples The example demonstrates limiting the number of file descriptors by passing the highest opened file descriptor to setrlimit/3 . - module ( setlimit ) . - export ( [ insn / 0 ] ) . - export ( [ close / 2 , setrlimit / 2 ] ) . insn ( ) -&gt; [ setlimit ( ) ] . setlimit ( ) -&gt; [ { open , [ &quot;/&quot; , [ o_rdonly ] ] } , { ? MODULE , close , [ ] , [ state ] } , { ? MODULE , setrlimit , [ ] , [ state ] } ] . close ( FD , Task ) -&gt; prx : close ( Task , FD ) . setrlimit ( FD , Task ) -&gt; prx : setrlimit ( Task , rlimit_nofile , \#{ cur =&gt; FD , max =&gt; FD } ) . Calling the module: 1 &gt; { ok , Task } = prx : fork ( ) . { ok , &lt; 0.186 . 0 &gt; } 2 &gt; { ok , Task1 } = prx : task ( Task , setlimit : insn ( ) , [ ] ) . { ok , &lt; 0.191 . 0 &gt; } 3 &gt; prx : execvp ( Task1 , [ &quot;sh&quot; , &quot;-c&quot; , &quot;ulimit -n&quot; ] ) . ok 4 &gt; flush ( ) . Shell got { stdout , &lt; 0.191 . 0 &gt; , &lt;&lt; &quot;7\\n&quot; &gt;&gt; } Shell got { exit_status , &lt; 0.191 . 0 &gt; , 0 } ok","ref":"prx_task.html#with/3","title":"prx_task.with/3","type":"function"},{"doc":"","ref":"prx_task.html#t:config/0","title":"prx_task.config/0","type":"type"},{"doc":"","ref":"prx_task.html#t:op/0","title":"prx_task.op/0","type":"type"},{"doc":"Options to modify the behavior of an operation: * state : pass ok result as the first parameter to the next operation (default: false) * errexit : abort operations on error (default: true) * transform : abort operations on error (default: true)","ref":"prx_task.html#t:option/0","title":"prx_task.option/0","type":"type"},{"doc":"An Erlang library for Unix process management and system programming tasks. prx provides: a safe, beam-friendly interface to system calls and other POSIX operations simple, reliable OS process management by mapping Erlang processes to a hierarchy of system processes an interface for privilege separation operations to restrict processes operations to isolate processes like containers and jails","ref":"readme.html","title":[79,118,101,114,118,105,101,119],"type":"extras"},{"doc":"$ rebar3 compile","ref":"readme.html#build","title":"Overview - Build","type":"extras"},{"doc":"prx has two basic operations: fork and exec. % Spawn a new system process { ok , Task } = prx :fork ( ) , % And a child of the process { ok , Child } = prx :fork ( Task ) . After fork()'ing, other calls can be made. For example: UID = prx :getuid ( Task ) , PID = prx :getpid ( Child ) . Calling exec() causes the process I/O to be treated as streams of data: ok = prx :execvp ( Child , [ &quot;/bin/cat&quot; , &quot;-n&quot; ] ) , prx :stdin ( Child , &quot;test \\n &quot; ) , receive { stdout , Child , Stdout } -&gt; Stdout end .","ref":"readme.html#quick-start","title":"Overview - Quick Start","type":"extras"},{"doc":"fork and exec /bin/cat { ok , Task } = prx :fork ( ) , ok = prx :execvp ( Task , [ &quot;/bin/cat&quot; , &quot;-n&quot; ] , prx :stdin ( Task , &quot;test \\n &quot; ) , receive { stdout , Task , _ } = Out -&gt; Out end . creating a pipeline of child processes prx processes can fork child prx processes: beam . smp | - erl_child_setup | ` - prx | ` - prx After calling exec, the process tree looks like: beam . smp | - erl_child_setup | ` - prx | ` - cat { ok , Task } = prx :fork ( ) , { ok , Child } = prx :fork ( Task ) , OSPid = prx :getpid ( Child ) , ok = prx :execvp ( Child , [ &quot;/bin/cat&quot; , &quot;-n&quot; ] , prx :stdin ( Child , &quot;test \\n &quot; ) , receive { stdout , Child , _ } = Out -&gt; Out end . running cat within a containerized namespace application :set_env ( prx , options , [ { exec , &quot;sudo -n&quot; } ] ) , { ok , Task } = prx :fork ( ) , { ok , Child } = prx :clone ( Task , [ clone_newnet , clone_newpid , clone_newipc , clone_newuts , clone_newns ] ) , OSPid = prx :getpid ( Child ) , ok = prx :execvp ( Child , [ &quot;/bin/cat&quot; , &quot;-n&quot; ] , prx :stdin ( Child , &quot;test \\n &quot; ) , receive { stdout , Child , _ } = Out -&gt; Out end .","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"https://hexdocs.pm/prx/ See also: alcove","ref":"readme.html#documentation","title":"Overview - Documentation","type":"extras"}]